

Type_uByte wvdFLASH_WriteBuffer(Type_uWord auwDstAddr, Type_uWord auwSrcAddr, Type_uHWord ahwWriteCount)
{
	Type_uByte aubRet = F_CONTINUE;
	Type_uWord auwDstAddrBackup;
	vType_uHWord ahwLoopCount;
	Type_uWord auwGuardCnt;

	auwDstAddrBackup = auwDstAddr;
	auwGuardCnt = 0;
	
	*(vType_uHWord*)((auwDstAddr & FLASH_SECTOR_ADDRESS_MASK) | FM_CMD_PROGRAM_ADDR_1_BYTE) = FM_CMD_PROGRAM_DATA_1;	/* First cycle  */
	*(vType_uHWord*)((auwDstAddr & FLASH_SECTOR_ADDRESS_MASK) | FM_CMD_PROGRAM_ADDR_2_BYTE) = FM_CMD_PROGRAM_DATA_2;	/* Second cycle */
	*(vType_uHWord*)(auwDstAddr & FLASH_SECTOR_ADDRESS_MASK) = FM_CMD_PROGRAM_DATA_3_WB;								/* Third cycle  */
	*(vType_uHWord*)(auwDstAddr & FLASH_SECTOR_ADDRESS_MASK) = ahwWriteCount - 1;										/* Fourth cycle */
	*(vType_uHWord*)((auwDstAddr) & FLASH_ADDRESS_MASK) = *(vType_uHWord*)(auwSrcAddr);								/* Fifth cycle  */
	  
	ahwLoopCount = ahwWriteCount - 1;
    while(ahwLoopCount > 0)
    {
    	auwDstAddr += 2;
		auwSrcAddr += 2;
		*(vType_uHWord*)((auwDstAddr) & FLASH_ADDRESS_MASK) = *(vType_uHWord*)(auwSrcAddr);								/* Fifth cycle  */
		ahwLoopCount--;
    }
	  
	*(vType_uHWord*)(auwDstAddrBackup & FLASH_SECTOR_ADDRESS_MASK)  = FM_CMD_PROGRAM_DATA_6_WB;								/* Sixth cycle  */
	  
	while(auwGuardCnt < 26000000)
	{
		/* Check DQ7 */
		if (((*(vType_uHWord*)(auwDstAddr)) & 0x80) == ((*(vType_uHWord*)(auwSrcAddr)) & 0x80))
		{
			/* If DQ7 is Data */
			aubRet = F_OK;
			break;
		}
		
		if (((*(vType_uHWord*)(auwDstAddr)) & 0x20) != 0)
		{
			wvdFLASH_WriteToBufAbortReset(auwDstAddr);

			if (((*(vType_uHWord*)(auwDstAddr)) & 0x80) != ((*(vType_uHWord*)(auwSrcAddr)) & 0x80))
			{
				aubRet = F_RESET;
				break;
			}
		}
			auwGuardCnt++;
	}
			
	return aubRet;
}

void wvdFLASH_WriteToBufAbortReset(Type_uWord auwDstAddr)
{
	
	*(vType_uHWord*)((auwDstAddr & FLASH_SECTOR_ADDRESS_MASK) | FM_CMD_PROGRAM_ADDR_1_BYTE) = FM_CMD_PROGRAM_DATA_1;	/* First cycle  */
	*(vType_uHWord*)((auwDstAddr & FLASH_SECTOR_ADDRESS_MASK) | FM_CMD_PROGRAM_ADDR_2_BYTE) = FM_CMD_PROGRAM_DATA_2;	/* Second cycle */
	*(vType_uHWord*)((auwDstAddr & FLASH_SECTOR_ADDRESS_MASK) | FM_CMD_PROGRAM_ADDR_3_BYTE) = FM_CMD_PROGRAM_DATA_REST;	/* Third cycle  */
}

void wvdFLASH_Reset(Type_uWord auwDstAddr)
{
	auwDstAddr |= FM_CS0_NO_CACHE_START;
	
	*(vType_uHWord*)(auwDstAddr & FLASH_SECTOR_ADDRESS_MASK) = FM_CMD_PROGRAM_DATA_REST;	/* First cycle  */
}



